<template>
  <div class="app-container pageTopForm">
    <el-form :model="queryParams" ref="queryRef" size="small" v-show="showSearch" label-width="auto" @submit.native.prevent>
      <el-col :span="6">
        <el-form-item label="配置名称" prop="configName">
          <el-input
            v-model="queryParams.configName"
            placeholder="请输入配置名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
      </el-col>
      <el-col :span="6">
        <el-form-item class="lastBtnSty">
          <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
          <el-button icon="Refresh" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-col>
    </el-form>
    <TableList :columns="columns" :config="config" :modelIdent="this.$options.name" :queryParams="queryParams" :tableList="tableList" @fnClick="callback" @fnRenderList="getList" @value-change="handleValueChange">
      <template #tempAlarmType="{ row, column }">
        <dict-tag :options="dict.type.alarm_type" :value="row.pushAlarmTypes"/>
      </template>
      <template #tempPushMethod="{ row, column }">
        <dict-tag :options="dict.type.push_method" :value="row.pushMethod"/>
      </template>
    </TableList>
  </div>
</template>

<script setup>
  import TableList from "@/components/table/index.vue"
  import {listAlarmPush, delAlarmPush} from "@/api/disRevenue/resource"
  export default {
    name: 'MessagePush',
    components: {TableList},
    dicts: ['alarm_type', 'push_method'],
    data() {
      return {
        loading: true,
        showSearch: true,
        tableList: [],
        queryParams: {
          total: 0,
          pageNum: 1,
          pageSize: 10
        },
        // 列显隐信息
        columns: {
          id: { label: `ID`,width: '50'},
          configName: { label: `配置名称`, minWidth: '120', visible: true },
          pushMethod: { label: `推送方式`, minWidth: '80', slotName: 'tempPushMethod', visible: true},
          pushAddress: { label: `推送地址`,minWidth: '150',visible: true},
          pushAlarmTypes: { label: `推送告警类型`,minWidth: '120', slotName: 'tempAlarmType', visible: true},
          messageContent: { label: `消息内容`,minWidth: '200', visible: true },
          contactPhones: { label: `消息提示人手机号`,minWidth: '150'},
          createBy: { label: `创建人`,minWidth: '80'},
          createTime: { label: `创建时间`,minWidth: '160'},
          updateTime: { label: `修改时间`,minWidth: '160'},
        },
        config: {
          tableButton: {
            top: [
              {content: '添加配置', fnCode: 'add', type: 'primary', icon: 'el-icon-plus', hasPermi: 'resource:messagePush:add'},
              {content: '删除', fnCode: 'delete', type: 'danger', icon: 'el-icon-delete', hasPermi: 'resource:messagePush:delete'},
              {content: '导出', fnCode: 'export', type: 'warning', icon: 'el-icon-download', hasPermi: 'resource:messagePush:export'},
            ],
            line: [
              {content: '修改', fnCode: 'edit', type: 'primary', icon: 'el-icon-edit', hasPermi: 'resource:messagePush:edit'},
              {content: '详情', fnCode: 'details', type: 'primary', icon: 'el-icon-view', hasPermi: 'resource:messagePush:details'},
            ]
          }
        }
      }
    },
    created() {
      this.getList();
    },
    activated() {
      this.$nextTick(() => {
        this.getList();
      });
    },
    methods: {
      /** 查询列表 */
      getList() {
        this.loading = true;
        listAlarmPush(this.queryParams).then(response => {
          this.tableList = response.rows;
          this.queryParams.total = response.total;
          this.loading = false;
        })
      },
      // 处理子组件传递的新值
      handleValueChange(newValue) {
        // 父组件更新自身数据，实现同步
        this.showSearch = newValue;
        // console.log('父组件拿到新值:', newValue);
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },

      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryRef");
        this.handleQuery();
      },

      callback(result, rowData, selectChange, selectList) {
        if (result && result.fnCode) {
          switch (result.fnCode) {
            case 'add':
              this.$router.push({
                path:'/resource/messagePush/details'});
              break;
            case 'edit':
              this.$router.push({
                path:'/resource/messagePush/details',
                query:{
                  id: rowData.id
                }
              });
              break;
            case 'details':
              this.$router.push({
                path: '/resource/messagePush/details',
                query: {
                  id: rowData.id,
                  readonly: true
                }
              });
              break;
            case 'delete':
              if (selectList && selectList.length <= 0) {
                this.$modal.msgWarning("请选择数据！");
                return;
              }
              this.$modal.confirm('是否确认删除数据项？').then(function() {
                return delAlarmPush(selectChange)
              }).then(() => {
                this.getList();
                this.$modal.msgSuccess("删除成功")
              }).catch(() => {});
              break;
            case 'export':
              // let dataList = [];
              // Object.keys(this.columns).forEach(item => {
              //   if (item.visible) {
              //     dataList.push(item.prop);
              //   }
              // });
              // this.download("/system/alarmManage/export", {properties: dataList,}, `拓扑管理_${new Date().getTime()}.xlsx`);
              let paramsList = Object.assign({}, this.queryParams,rowData);
              this.download("rocketmq/alarmPushConfig/export", paramsList, `消息推送_${new Date().getTime()}.xlsx`, null, 'json');
              break;
            default:
          }
        }
      }
    }
  }
</script>
<style scoped>
  ::v-deep .lastBtnSty .el-form-item__content{
    margin-left: 10px!important;
  }
</style>
